// TCP/IP Stack Javascript Library. http://www.kernelchip.ru
// Version: 3.01 
var timeOutMS = 5000; //ms 
var ajaxList = new Array();

function newAJAXCommand(url, container, repeat, data) {	
var newAjax = new Object();
var theTimer = new Date();
newAjax.url = url;
newAjax.container = container;
newAjax.repeat = repeat;
newAjax.ajaxReq = null;	
	
	if(window.XMLHttpRequest) {
        newAjax.ajaxReq = new XMLHttpRequest();
        newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
        newAjax.ajaxReq.send(data); 
    } else if(window.ActiveXObject) {
        newAjax.ajaxReq = new ActiveXObject("Microsoft.XMLHTTP");
        if(newAjax.ajaxReq) {
            newAjax.ajaxReq.open((data==null)?"GET":"POST", newAjax.url, true);
            newAjax.ajaxReq.send(data);
        }
    }    
    newAjax.lastCalled = theTimer.getTime();   
    ajaxList.push(newAjax);
}

function pollAJAX() {	
	var curAjax = new Object();
	var theTimer = new Date();
	var elapsed;	

	for(i = ajaxList.length; i > 0; i--)	{
		curAjax = ajaxList.shift();
		if(!curAjax)
			continue;
		elapsed = theTimer.getTime() - curAjax.lastCalled;				
	
		if(curAjax.ajaxReq.readyState == 4 && curAjax.ajaxReq.status == 200) {			
		  if(typeof(curAjax.container) == 'function'){
		    if (curAjax.ajaxReq.responseXML) curAjax.container(curAjax.ajaxReq.responseXML.documentElement);
		    else if (curAjax.ajaxReq.response) curAjax.container(curAjax.ajaxReq.response);
		  } else if(typeof(curAjax.container) == 'string') {
		    document.getElementById(curAjax.container).innerHTML = curAjax.ajaxReq.responseText;
		  } 
			
	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;
			
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}	
		
		if(elapsed > timeOutMS) {			
			if(typeof(curAjax.container) == 'function'){
				curAjax.container(null);
			} else {				
				//alert("Command failed.");
			}

	    	curAjax.ajaxReq.abort();
	    	curAjax.ajaxReq = null;
						
			if(curAjax.repeat)
				newAJAXCommand(curAjax.url, curAjax.container, curAjax.repeat);
			continue;
		}		
		ajaxList.push(curAjax);
	}	
	setTimeout("pollAJAX()", 100);	
}			

function getXMLValue(xmlData, field) {
	try {
		if(xmlData.getElementsByTagName(field)[0].firstChild.nodeValue)
			return xmlData.getElementsByTagName(field)[0].firstChild.nodeValue;
		else
			return null;
	} catch(err) { return null; }
}

setTimeout("pollAJAX()", 500);

/////////////////////////////////////////////////////////////////////
var SLOW_INFO_SN            = 1;
var SLOW_INFO_FW            = 2;
var SLOW_INFO_JIOTABLE      = 3;
var SLOW_INFO_IP            = 4;
var SLOW_INFO_MAC           = 5;
var SLOW_INFO_MSK           = 6;
var SLOW_INFO_GTW           = 7;
var SLOW_INFO_SPB           = 8;
var SLOW_INFO_EXTSRV        = 9;
var SLOW_INFO_BITSET        = 10;
var SLOW_INFO_PSW           = 11;
var SLOW_INFO_COUNT_CYCLES  = 12;
var SLOW_INFO_TOTAL         = 13;
/////////////////////////////////////////////////////////////////////

function CatcherObject() {
  this.eCatType     = 0;        
  this.bEnabled     = 0;        
  this.bExtServer   = 0;
    
  this.timer        = 0;
  this.uiInLine     = 0;
  this.LineEvtType  = 0;
  this.uiExtraParam = 0;
    
  this.uiOutLineNumber = 0; 
  this.uiOutValue   = 0;      
  this.uiOutDelay   = 0;    
    
  this.cnt = 0;
}
var CAT_ARRAY_SIZE = 20;

function Laurent_112Object() {
  this.Connected  = 0;      
  this.time      =  0;
  this.sn        = "";
  this.fw        = "";   
  this.REL  = new Array();  

  // Catcher ARRAY
  this.cat = new Array();
  for( i = 0; i < CAT_ARRAY_SIZE; i++) {
      this.cat[i] = new CatcherObject();
  }
  var bCatcherInfoNew = 0;
  var bCatcherCntNew  = 0;
  var bSlowInfoNew    = 0;
  
  this.pass = "";
  this.ip   = "";
  this.mac  = "";
  this.mask = "";
  this.gate = "";  
  this.security = true;  
  this.fw_load  = false; 
  this.sav      = false; 
  this.rmt_srv  = "";   
  
  
  for(i = 0; i < 12; i++)  this.REL[i] = 0;
      
  this.IsConnected = function() { return this.Connected; }
  this.GetTime = function() { return this.time; } 
  this.GetSN = function() { return this.sn; }  
  this.GetFW = function() { return this.fw; }  
  this.GetRele = function(n) { return this.REL[n]; }
    
  this.GetPass = function() { return this.pass; }
  this.GetIP = function() { return this.ip; }
  this.GetMAC = function() { return this.mac; } 
  this.GetMask = function() { return this.mask; } 
  this.GetGate = function() { return this.gate; } 
    
  this.GetSEC = function() { return this.security; } 
  this.GetFWL = function() { return this.fw_load; }
  this.GetSAV = function() { return this.sav; }
  
  var srv = "server.cgi?data";

  this.Ready = function(){ 
      newAJAXCommand(srv+'=OKK,'); }

  this.SetRele = function(ReleIdx){ 
  newAJAXCommand(srv+'=REL,'+ReleIdx+'$'); }

  this.SetOUT = function(LineIdx){
  newAJAXCommand(srv+'=OUT,'+LineIdx);}

  this.SetPWM = function(NewPwm){ 
  newAJAXCommand(srv+'=PWM,'+NewPwm);}  

  this.SetPass = function(value){  
  newAJAXCommand(srv+'=PAS,' + value);}

  this.SetIP = function(value){ 
  newAJAXCommand(srv+'=IPX,' + value + '$');}

  this.SetMAC = function(value){ 
  newAJAXCommand(srv+'=MAC,' + value + '$');}
  
  this.SetMSK = function(value){ 
  newAJAXCommand(srv+'=MSK,' + value + '$');}
  
  this.SetGTW = function(value){ 
  newAJAXCommand(srv+'=GTW,' + value + '$');}
  
  this.SetSEC = function(value){ 
  newAJAXCommand(srv+'=SEC,' + value);}
  
  this.SetFWL = function(value){ 
  newAJAXCommand(srv+'=FWL,' + value);}
  
  this.SetSAV = function(value){ 
      newAJAXCommand(srv+'=SAV,' + value);}

  this.SetKEVT = function(value){ 
    newAJAXCommand(srv+'=KEVT,' + value);}

  this.SetDZG = function(value){ 
    newAJAXCommand(srv+'=DZG,' + value);}

  this.SetBaud = function(value){
  newAJAXCommand(srv+'=BAU,' + value);}
  
  this.SendUSART = function(value, cr_lf){
  newAJAXCommand(srv+'=USR,' + cr_lf + ',' + value.length + ',' + value);}

  this.Reset = function(){
  newAJAXCommand(srv+'=RST');}

  this.Default = function(){
      newAJAXCommand(srv+'=DEF');} 

  this.SetCAT_ALL_Action = function( action ) {      
      newAJAXCommand(srv+'=ACAT,' + action );
  }

  this.SetCAT_I_Action = function( idx, action ) {      
      newAJAXCommand(srv+'=ICAT,' + idx + ',' + action  );
  }

  this.SetCAT_New = function( mes ) {     
      newAJAXCommand(srv+'=NCAT,' + mes  );
  }      

  this.UpdateCAT_Info = function(){
    newAJAXCommand(srv+'=UCAT');} 
      
  this.UpdateStatus = function(xmlData){   
  if( !xmlData ) { this.Connected = 0; return; }  
  
  this.Connected = 1;
  var TempLoc;

  TempLoc = getXMLValue( xmlData, 'systime0' );
  if( TempLoc ) this.time = TempLoc;
     
  var ReleTempTable = getXMLValue( xmlData, 'rele_table0' );
  if( ReleTempTable ) {
      for( i = 0; i < 12; i++ ) this.REL[i] = ReleTempTable.charAt(i);  
  }
   
  // Slow information...
  TempLoc = getXMLValue(xmlData, 'slow_info0');
  if (TempLoc) {
      // <data id>,<data>
      var TempArr = TempLoc.split(',');
      if (TempArr.length != 2) return;
      switch ( parseInt(TempArr[0]) ) {
          case SLOW_INFO_SN: {
              this.sn = TempArr[1];
              break;
          }
          case SLOW_INFO_FW: {
              this.fw = TempArr[1];
              break;
          }          
          case SLOW_INFO_IP: {
              this.ip = TempArr[1];
              break;
          }
          case SLOW_INFO_MAC: {
              this.mac = TempArr[1];
              break;
          }
          case SLOW_INFO_MSK: {
              this.mask = TempArr[1];
              break;
          }
          case SLOW_INFO_GTW: {
              this.gate = TempArr[1];
              break;
          }               
          case SLOW_INFO_BITSET: {
              // Security, SAV, EVT, DZG
              this.security = false;
              this.sav  = false;
              this.kevt = false;
              this.dzg  = false;
              var ch = TempArr[1].charAt(0);
              if( ch == '1' ) this.security = true;              
              ch = TempArr[1].charAt(1);
              if( ch == '1' ) this.sav = true;   
              ch = TempArr[1].charAt(2);
              if( ch == '1' ) this.kevt = true;
              ch = TempArr[1].charAt(3);
              if( ch == '1' ) this.dzg = true;
              break;
          }          
          case SLOW_INFO_PSW: {
              this.pass = TempArr[1];
              break;
          }          
          default: {
              break;
          }
      }   // end Switch   
      bSlowInfoNew = 1;
  } // IF valid data

  ////////////////////////////////////////////////////////////
  // Catcher information...
  TempLoc = getXMLValue(xmlData, 'cat_inf0');
  if(TempLoc) {         
      var TempArr = TempLoc.split(',');
      var len = TempArr.length;

      var idx = parseInt(TempArr[0]);      

      if( idx > CAT_ARRAY_SIZE-1 ) return;      

      this.cat[idx].bEnabled = parseInt(TempArr[1]);
      this.cat[idx].eCatType = TempArr[2];
      if( TempArr[2] == "L" ){
          this.cat[idx].uiInLine        = parseInt(TempArr[3]);
          this.cat[idx].LineEvtType     = parseInt(TempArr[4]); 
          this.cat[idx].uiOutLineNumber = parseInt(TempArr[5]);
          this.cat[idx].uiOutValue      = parseInt(TempArr[6]);         
      }
      else if( TempArr[2] == "T" ){
          this.cat[idx].timer           = parseInt(TempArr[3]); 
          this.cat[idx].uiOutLineNumber = parseInt(TempArr[4]);
          this.cat[idx].uiOutValue      = parseInt(TempArr[5]);          
          this.cat[idx].uiOutDelay      = parseInt(TempArr[6]);
      } 
      else if( TempArr[2] == "K" ){
          this.cat[idx].uiInLine        = parseInt(TempArr[3]); 
          this.cat[idx].LineEvtType     = TempArr[4];
          this.cat[idx].timer           = parseInt(TempArr[5]); 
          this.cat[idx].uiOutLineNumber = parseInt(TempArr[6]);
          this.cat[idx].uiOutValue      = parseInt(TempArr[7]); 
      } 
      else if( TempArr[2] == "P" ){
          this.cat[idx].uiExtraParam    = TempArr[3];  
          this.cat[idx].timer           = parseInt(TempArr[4]); 
          this.cat[idx].uiOutLineNumber = parseInt(TempArr[5]);
          this.cat[idx].uiOutValue      = parseInt(TempArr[6]); 
      } 
      else if( TempArr[2] == "Z" ){          
          this.cat[idx].eCatType        = 0;        
          this.cat[idx].bEnabled        = 0;        
          this.cat[idx].bExtServer      = 0;    
          this.cat[idx].timer           = 0;
          this.cat[idx].uiInLine        = 0;
          this.cat[idx].LineEvtType     = 0;    
          this.cat[idx].uiOutLineNumber = 0; 
          this.cat[idx].uiOutValue      = 0;      
          this.cat[idx].uiOutDelay      = 0;      
          this.cat[idx].cnt             = 0;
          this.cat[idx].uiExtraParam    = 0;
      }            
      this.bCatcherInfoNew = 1;
  } // IF valid data
  ////////////////////////////////////////////////////////////  

  // Catcher counters... (Packet x5 cnt)
  TempLoc = getXMLValue(xmlData, 'cat_cnt0');
  if( TempLoc ) {     
    var TempArr = TempLoc.split(',');
    var len = TempArr.length;
    if( len != 6 ) return;
    var PackId = parseInt(TempArr[0]);   
    if( PackId >= 5 ) return;
    for( i = 0; i < 5; i++ ) {
      this.cat[PackId*5 + i].cnt = parseInt(TempArr[1+i]); 
      if( this.cat[PackId*5 + i].cnt == -1 )
        this.cat[PackId*5 + i].cnt = '-';
    }
    // Raise the flag... somethig new has just arrived
    this.bCatcherCntNew = 1;
  } // IF valid data  

  }
    
  this.Run = function(){
  setTimeout( "newAJAXCommand('status.xml', updateStatusLaurent, true)", 1000 );
  }
}

var bLaurentExists_XX = false;
var ObjLaurent_XX = null;

function GetLaurent_112Object() {
  if( !bLaurentExists_XX ) {
    ObjLaurent_XX = new Laurent_112Object();
    bLaurentExists_XX = true;
  }
  return ObjLaurent_XX; 
}

function updateStatusLaurent( xmlData ) {
  ObjLaurent_XX.UpdateStatus( xmlData );   
}
